/******************************************************************************

	invert.c

	Performs a bitwise negation on the whole file
	
	(c) 2006 by Ansgar Kueckes (kueckes@alice-dsl.net)

******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

void print_usage(char *command)
{
	printf("Usage: %s <infile> <outfile>\n", command);
	printf("       <infile>  binary input file\n");
	printf("       <outfile>  binary output file (inverted)\n");
	return;
}

int main(int argc, char *argv[])
{
  int count;
  char *infile = 0;
  char *outfile = 0;
  FILE *ifp,*ofp;
  int c;
  
  if (argc < 3) { print_usage(argv[0]); exit(0); }

  /* command line processing */
  for ( count = 1; count < argc ; count++)
  {
	if (!strncmp(argv[count], "-", 1) && (count < argc))
		 { print_usage(argv[0]); exit(0); }

	if (!infile) { infile = argv[count]; continue; }
	if (!outfile) { outfile = argv[count]; continue; }
  }
  
  if (!infile) { print_usage(argv[0]); exit(0); }
  if (!outfile) { print_usage(argv[0]); exit(0); }
  
  /* open ROM image files */
  ifp = fopen( infile, "rb");
  if (!ifp) { fprintf(stderr, "Could not open file \"%s\".\n", infile); exit(-1); }

  ofp = fopen( outfile, "wb");
  if (!ofp) { fprintf(stderr, "Could not open file \"%s\".\n", outfile); exit(-1); }
  
  printf("%s %s\n", infile, outfile);
  
  while (!feof(ifp)) {
  	c=fgetc(ifp);
  	if (c!=EOF) fputc(~((unsigned char)c), ofp);
  }
  
  /* cleanup */
  if (ifp) fclose(ifp);
  if (ofp) fclose(ofp);
  exit(0);
}
